Subject: Re: [RFC PATCH] net: add dataref destructor to sk_buff

From: Evgeniy Polyakov <[email-masked]>
Date: Wed, 11 Nov 2009 00:40:48 +0300

On Tue, Nov 10, 2009 at 01:36:23PM -0500, Gregory Haskins ([email-masked]) wrote:
> What about things like sendfile()?  There has to be *some* way to
> synchronize with the io-completion event,  I would think.  Whatever that
> is, I'd like to tap into it.

All skb manipulation functions properly maintain data reference
counters, so pages will not be freed until all data is consumed.
But there is no guarantee that data placed in given page will not be
overwritten while page is being held somewhere in the stack.

Putting shared info destructor will allow to get notification, that
given shared info processing is over, i.e. that network stack does not
use data placed in shared info for given skb, but if it was copied or
VFS hold those pages, they may or may not be freed.

-- 
	Evgeniy Polyakov